'11/07/24 Serial data relay to JS - Sensmi comm mod - RLB
'plugin requires custom autorun to handle sent serial advanced commands 
'for BA:Connected - autorun version 10.0.100 

'plugin name - NodeSensmisender

Function NodeSensmisender_Initialize(msgPort As Object, userVariables As Object, bsp as Object)

    print "NodeSensmisender_Initialize - entry"
    print "type of msgPort is ";type(msgPort)
    print "type of userVariables is ";type(userVariables)

    NodeSensmisender = newNodeSensmisender(msgPort, userVariables, bsp)

    return NodeSensmisender

End Function



Function newNodeSensmisender(msgPort As Object, userVariables As Object, bsp as Object)
	
	' Create the object to return and set it up
	s = {}
	'''''''''''''''''''''''''''''''''
	'BACon tested version - 1.37.1 which uses autorun version 10.0.100
	s.BA_autorun_tested = "10.0.100"
	'''''''''''''''''''''''''''''''''
	s.version = "7.1"
	s.msgPort = msgPort
	s.userVariables = userVariables
	s.bsp = bsp
	s.ProcessEvent = NodeSensmisender_ProcessEvent
	s.HandlePluginTimerEvent = HandlePluginTimerEvent
	s.HandleSentPluginMsg = HandleSentPluginMsg
	s.PluginSendMessage = PluginSendMessage
	s.PluginSendZonemessage = PluginSendZonemessage
	s.udpSender = CreateObject("roDatagramSender")
	s.udpSendPort = 5000
	s.udpAddress$ = "255.255.255.255"	
	s.udpSender.SetDestination(s.udpAddress$, s.udpSendPort)
	s.udpReceivePort = 5000
    s.udpReceiver = CreateObject("roDatagramReceiver", s.udpReceivePort)
    s.udpReceiver.SetUserData("receiver")
    s.udpReceiver.SetPort(s.msgPort)  
	s.PluginSystemLog = CreateObject("roSystemLog")
	s.sTime = createObject("roSystemTime")
	s.objectName = "NodeSensmisender_object_plugin"
	s.StartIndexedSequenceTimer = StartIndexedSequenceTimer
  	s.SensmiUnpack = SensmiUnpack
	s.CheckAutorun = CheckAutorun
	s.HandleStreamEventPlugin = HandleStreamEventPlugin
  	s.PluginInitHTMLWidgetStatic = PluginInitHTMLWidgetStatic
	s.CheckUservariableValue = CheckUservariableValue
	s.StartDelayTimer = StartDelayTimer
	s.FirstSerialmsg = true
	s.delaytimeout = 70000 '70 seconds timeout to send uservariable value to HTMLWidget
	's.FunctionSequenceOrderAr = [["CheckAutorun",2000]]
	s.FunctionSequenceOrderAr = [["SensmiUnpack",2000],
								["PluginInitHTMLWidgetStatic",5000],
								["CheckAutorun",60000]]
  's.FunctionSequenceOrderAr = [["PluginInitHTMLWidgetStatic",2000]]
	s.FunctionListIndex = 0
	s.StartIndexedSequenceTimer(s.FunctionSequenceOrderAr[s.FunctionListIndex][0], s.FunctionSequenceOrderAr[s.FunctionListIndex][1])

	print "newNodeSensmisender Plugin - V" + s.version

	s.PluginSystemLog.sendline("newNodeSensmisender Plugin - V" + s.version)

	return s

End Function



Function NodeSensmisender_ProcessEvent(event As Object) as boolean

	retval = false
	' print ""
    ' print "NodeSensmisender_ProcessEvent - entry"
    ' print "type of m is ";type(m)
    ' print "NodeSensmisender_ProcessEvent - type of event is ";type(event)
	' print ""

	if type(event) = "roAssociativeArray" then
		if type(event["EventType"]) = "roString"

			' print ""
			' print " @@@ Event Type "; event["EventType"]
			' print ""

			'USER_VARIABLES_UPDATED
			if (event["EventType"] = "USER_VARIABLES_UPDATED") then
				if m.bsp.sign.zoneshsm[0].loadinghtmlwidget <> invalid then

					' if m.bsp.currentuservariables.sensorvar1 <> invalid AND m.bsp.currentuservariables.sensorvar2 <> invalid AND m.bsp.currentuservariables.sensorvar3 <> invalid then
					' 	m.bsp.sign.zoneshsm[0].loadinghtmlwidget.PostJSMessage({sensorvarlist: variableList})
					'end if	
				end if	
			end if	

			if event["EventType"] = "USER_VARIABLE_CHANGE" then

				' print ""
				' print " @@@ event - USER_VARIABLE_CHANGE event.UserVariable @@@ ";
				' print event.UserVariable.name$ 
				' print ""
			end if

			if (event["EventType"] = "SEND_ZONE_MESSAGE") then
				payload$ = event["EventParameter"]
			end if

			if (event["EventType"] = "SEND_PLUGIN_MESSAGE") then
				if event["PluginName"] = "NodeSensmisender" then
					pluginMessage$ = event["PluginMessage"]
					'sent Plugin messages
					print "SEND_PLUGIN/EVENT_MESSAGE: ";pluginMessage$
					m.PluginSystemLog.sendline(" @@@ SEND_PLUGIN/EVENT_MESSAGE:  " + pluginMessage$)
					retval = HandleSentPluginMsg(pluginMessage$, m)
				end if
			else if (event["EventType"] = "EVENT_PLUGIN_MESSAGE") then
				if event["PluginName"] = "NodeSensmisender" then
					pluginMessage$ = event["PluginMessage"]
					'acting on Transition Events defined within BA
					print "EVENT_PLUGIN_MESSAGE: ";pluginMessage$
					m.PluginSystemLog.sendline(" @@@ EVENT_PLUGIN_MESSAGE:  " + pluginMessage$)
				end if
			end if
		end if
	else if type(event) = "roHtmlWidgetEvent" then
	
		eventData = event.GetData()
		
		if type(eventData) = "roAssociativeArray" and type(eventData.reason) = "roString" then
		
            Print "!!!!!reason in Plugin!!!!! = " + eventData.reason
			
			if eventData.reason = "message" then
				
				if instr(0, eventData.message.jsmsg, "JSserial:") > 0 then

					RegexSep = CreateObject("roRegex", ":", "i")	
					FindRegExSep = RegexSep.IsMatch(eventData.message.jsmsg)	
					FindSepSplitBlocks = RegexSep.split(eventData.message.jsmsg)
					prefix = "NXListen:"
					trimmedVal = left(FindSepSplitBlocks[1],len(FindSepSplitBlocks[1]))
					'formattedVal = prefix + trimmedVal
					'm.udpSender.send(formattedVal)
					print ""
					print"trimmedVal: "; trimmedVal
					print ""

					if type(m.bsp.serial) = "roAssociativeArray" then
						serial = m.bsp.serial["2"]
						if type(serial) = "roSerialPort" then
							serial.SendLine(trimmedVal)
						endif
					endif
				end if 	

			else if eventData.reason = "load-finished" then	
				m.StartDelayTimer(m.delaytimeout)
			end if			
		end if	
	else if type(event) = "roTCPConnectEvent" then
		'retval = HandlePluginTCPConnectEvent(event, m)
	else if type(event) = "roStreamLineEvent" then
		retval = HandleStreamEventPlugin(event, m)	
		'retval = HandlePluginTCPStreamLineEvent(event, m)
	else if type(event) = "roStreamEndEvent" then
		'retval = HandlePluginStreamEndEvent(event, m)	
	else if type(event) = "roTimerEvent" then
		retval = HandlePluginTimerEvent(event, m)
	else if type(event) = "roDatagramEvent" then
		'retval = HandlePluginUDPEvent(event, m)	
	end if

	return retval
End Function



Function StartIndexedSequenceTimer(FunctionName as String, TimeoutVal as integer)

    userdata = {}
    userdata.FunctionName = FunctionName
    userdata.TimeoutVal = TimeoutVal

    newTimeout = m.sTime.GetLocalDateTime()
    newTimeout.AddMilliseconds(TimeoutVal)
    m.IndexedSequenceTimer = CreateObject("roTimer")
    m.IndexedSequenceTimer.SetPort(m.msgPort)	
    m.IndexedSequenceTimer.SetDateTime(newTimeout)
    m.IndexedSequenceTimer.SetUserData(userdata)	
    ok = m.IndexedSequenceTimer.Start()

    'print "Before: "; m.sTime.GetLocalDateTime()
End Function


Function StartDelayTimer(TimeoutVal as integer)

    newTimeout = m.sTime.GetLocalDateTime()
    newTimeout.AddMilliseconds(TimeoutVal)
    m.DelayTimer = CreateObject("roTimer")
    m.DelayTimer.SetPort(m.msgPort)	
    m.DelayTimer.SetDateTime(newTimeout)
    ok = m.DelayTimer.Start()
End Function


Function HandlePluginTimerEvent(origMsg as Object, m as Object) as boolean

		timerIdentity = origMsg.GetSourceIdentity()
		
		if type(m.IndexedSequenceTimer) = "roTimer" then
			
			if m.IndexedSequenceTimer.GetIdentity() = origMsg.GetSourceIdentity() then

				'print "After: "; m.sTime.GetLocalDateTime()

				userData = origMsg.GetUserData()
				'print "FunctionName: "; userData.FunctionName
				'print "TimeoutVal: ";  userData.TimeoutVal

				FunctionName = userData.FunctionName

				if FunctionName = "PluginInitHTMLWidgetStatic" then
					m.PluginInitHTMLWidgetStatic()
				else if FunctionName = "SensmiUnpack" then
					m.SensmiUnpack()
				else if FunctionName = "CheckAutorun" then	
					m.CheckAutorun()		  
				end if   

				if m.FunctionListIndex < m.FunctionSequenceOrderAr.count() - 1 then
					m.FunctionListIndex = m.FunctionListIndex + 1
					m.StartIndexedSequenceTimer(m.FunctionSequenceOrderAr[m.FunctionListIndex][0], m.FunctionSequenceOrderAr[m.FunctionListIndex][1])
				end if 
				
				return true
			end if
		end if
	if type(m.DelayTimer) = "roTimer" then
		if m.DelayTimer.GetIdentity() = origMsg.GetSourceIdentity() then
			retrievedValues = m.CheckUservariableValue("Sensmi")
			if m.bsp.PluginHTMLWidget <> invalid then
				' Post all retrieved values as a JSON object
				for each key in retrievedValues
					m.bsp.PluginHTMLWidget.PostJSMessage({NXSend: key + ":" + retrievedValues[key]})
				end for
			end if  
		end if
	end if
End Function



Function PluginSendMessage(Pmessage$ As String)

	pluginMessageCmd = CreateObject("roAssociativeArray")
	'pluginMessageCmd["EventType"] = "EVENT_PLUGIN_MESSAGE"
	pluginMessageCmd["EventType"] = "SEND_PLUGIN_MESSAGE"
	pluginMessageCmd["PluginName"] = "NodeSensmisender"
	pluginMessageCmd["PluginMessage"] = Pmessage$
	m.msgPort.PostMessage(pluginMessageCmd)
End Function



Sub PluginSendZonemessage(msg$ as String)
	' send ZoneMessage message
	zoneMessageCmd = CreateObject("roAssociativeArray")
	zoneMessageCmd["EventType"] = "SEND_ZONE_MESSAGE"
	zoneMessageCmd["EventParameter"] = msg$
	m.msgPort.PostMessage(zoneMessageCmd)
End Sub



Function PluginInitHTMLWidgetStatic()

	Print " Creating HTMLWidget..."

	m.PluginRect = CreateObject("roRectangle", 0,0,1920,1080)


	is = {
		port: 2999
	}
	m.config = {
		nodejs_enabled: true
		security_params: {websecurity: false, insecure_https_enabled: true}
		javascript_injection: {
		   document_creation: [],
			'document_ready: [{source: filepath$ }],
			document_ready: [],
			'deferred: [{source: filepath$ }]
			deferred: []
		},
		javascript_enabled: true,
		port: m.msgPort,
		inspector_server: is,
		brightsign_js_objects_enabled: true,
		url: "file:///sd:/sensmi/index.html",
		mouse_enabled: true,
		storage_quota: "2000000000",
		storage_path: "local",
		'transform: "rot90",
		user_agent: ""
	}

	m.bsp.PluginHTMLWidget = CreateObject("roHtmlWidget", m.PluginRect, m.config)
	'm.PluginHTMLWidget.Show()

  print "=== NodeSensmisender_Initialize - done"
End Function



Function SensmiUnpack()

	SensmiZIPPathinPool$ = m.bsp.assetPoolFiles.getPoolFilePath("sensmi.zip")

	if SensmiZIPPathinPool$ <> "" then
		nodePackage = createObject("roBrightPackage", m.bsp.assetPoolFiles.getPoolFilePath("sensmi.zip"))

		if nodePackage <> invalid then
			 CreateDirectory("sensmi")
			nodePackage.Unpack("sensmi")
		end if
	else 
		m.PluginSystemLog.sendline("@@@ Unable to find sensmi.zip file in pool")		
	end if 	
End Function



Function CheckAutorun()
	currentAutorunFile$ = ReadAsciiFile("sd:/autorun.brs")

	quotationMark = chr(34)
	equalsSign = chr(61)
	BAConversionCheck$ = "autorunVersion$ " + equalsSign + " " + quotationMark + m.BA_autorun_tested + quotationMark

	'autorunVersion$ = "10.0.100" 

	if instr(0, currentAutorunFile$, BAConversionCheck$) > 0 then
		print ""
		print " @@@ Matched and Found BAConversionCheck$: "; BAConversionCheck$
		print ""
		m.PluginSystemLog.sendline("@@@ Matched and Found BAConversionCheck$: " + BAConversionCheck$)
	
		if instr(0, currentAutorunFile$, "RLB-SENSMI-CUSTOM-AUTORUN-") > 0 then
			print ""
			print "RLB-SENSMI-CUSTOM-AUTORUN FOUND!!!"
			print ""
			m.PluginSystemLog.sendline("@@@ RLB-SENSMI-CUSTOM-AUTORUN FOUND ON SD CARD!!!")
		else 	
			print ""
			print "RLB-SENSMI-CUSTOM-AUTORUN NOT FOUND ON SD CARD!???"
			print ""
			m.PluginSystemLog.sendline("@@@ RLB-SENSMI-CUSTOM-AUTORUN NOT FOUND ON SD CARD!???")

			autorunPathinPool$ = m.bsp.assetPoolFiles.getPoolFilePath("BACon_10_0_100_autorun_Custom_Sensmi_RLB.txt")

			if autorunPathinPool$ <> "" then
				print ""
				print "@@@ Custom autorun FOUND in asset pool"
				print ""
				m.PluginSystemLog.sendline("@@@ Custom autorun FOUND in asset pool")
				renamedAutorunOK = MoveFile("autorun.brs", "old-autorun.brs")
				if renamedAutorunOK then
					newAutorunCopiedOK = CopyFile(autorunPathinPool$, "sd:/autorun.brs")
					if newAutorunCopiedOK then
						print ""
						print "@@@ Plugin initiated reboot..."
						print ""
						m.PluginSystemLog.sendline("@@@ Plugin initiated reboot...")
						RebootSystem()
					end if 	
				end if
			else 
				print ""
				print "@@@ Custom autorun NOT found in asset pool"
				print ""
				m.PluginSystemLog.sendline("@@@ Custom autorun NOT found in asset pool")		
			end if	
		end if
	else
		print ""
		print " @@@ Unexpected autorun version, cannot setup Sensmi customisation "
		print ""
		m.PluginSystemLog.sendline("@@@ Unexpected autorun version, cannot setup Sensmi customisation")	
	end if		
End Function


Function HandleSentPluginMsg(origMsg as string, m as object) as boolean
	retval = false
		
	' convert the message to all lower case for easier string matching later
	msg = lcase(origMsg)
	print "Received Plugin message: " + msg

	return (retVal)
end Function



Function HandleStreamEventPlugin(origMsg as Object, m as object) as boolean

	'print " HandleStreamEventPlugin "; origMsg

	retval = false

	if instr(1, origMsg, "X00") = 1 then
		'stop
		if m.bsp.PluginHTMLWidget <> invalid then
			m.bsp.PluginHTMLWidget.PostJSMessage({NXSend: origMsg})
		end if
	else 	
		if m.bsp.PluginHTMLWidget <> invalid then
			m.bsp.PluginHTMLWidget.PostJSMessage({NXSend: origMsg})
		end if  
	end if 	
     
	return retval
End Function



Function CheckUservariableValue(prefix)

    ' Initialize an associative array to hold the retrieved values
    retrievedValues = {}

    ' List of specific keys to check for
    specificKeys = [
        "SensmiHOST",
        "SensmiPORT",
        "SensmiHEARTBEAT",
        "SensmiPROVISION_KEY",
        "SensmiPROVISION_SECRET",
        "SensmiCUSTOMER",
        "SensmiEngagement_Ports",
        "SensmiFiltersCountry",
        "SensmiFiltersArea",
        "SensmiFiltersCity",
        "SensmiFiltersMall",
        "SensmiFiltersStore",
        "SensmiFiltersLongitude",
        "SensmiFiltersLatitude",
        "SensmiFiltersSolution",
        "SensmiFiltersTemplate",
        "SensmiModule1Ports",
        "SensmiModule1Port_prefix",
        "SensmiModule1EMF",
        "SensmiModule1EMF_Module",
        "SensmiModule2Ports",
        "SensmiModule2Port_prefix",
        "SensmiModule2EMF",
        "SensmiModule2EMF_Module",
        "SensmiModule3Ports",
        "SensmiModule3Port_prefix",
        "SensmiModule3EMF",
        "SensmiModule3EMF_Module",
        "SensmiModule4Ports",
        "SensmiModule4Port_prefix",
        "SensmiModule4EMF",
        "SensmiModule4EMF_Module"
    ]

    ' Loop through the list of specific keys
    for each key in specificKeys
        ' Check if the key exists in the current user variables
        if m.bsp.currentuservariables[key] <> invalid then
            ' Retrieve the current value of the key
            uservariableVal = m.bsp.currentuservariables[key].GetCurrentValue()
            retrievedValues[key] = uservariableVal

            ' Log and print the retrieved value
            m.PluginSystemLog.SendLine("@@@ Param value retrieved from user variable: " + key + " = " + uservariableVal)
            print "@@@ Param value retrieved from user variable: " + key + " = " + uservariableVal
        end if
    end for

    ' Return the associative array of retrieved values
    return retrievedValues
End Function
